addHook("ThinkFrame", function()
    for player in players.iterate
        if player.spinitem
            player.spinitem = 0
        end
    end
end)

addHook("ThinkFrame", do
for player in players.iterate do
if player.mo and player.mo.valid
if player.mo.skin == "adventuresonic" return end
if player.pflags & PF_JUMPED or player.pflags & PF_THOKKED or player.pflags & PF_STASIS or player.pflags & PF_JUMPSTASIS return end
if (player.panim == PA_IDLE or player.panim == PA_WALK or player.panim == PA_RUN or player.panim == PA_DASH)
and not P_IsObjectOnGround(player.mo)
and player.mo.momz < 1
and not player.powers[pw_carry]
player.mo.state = S_PLAY_FALL
end
if (player.panim == PA_IDLE or player.panim == PA_WALK or player.panim == PA_RUN or player.panim == PA_DASH)
and not P_IsObjectOnGround(player.mo)
and player.mo.momz > 0
and not player.powers[pw_carry]
player.mo.state = S_PLAY_SPRING
end
end
end
end)

addHook("ThinkFrame", function()
    for player in players.iterate do
	 --local player = mo.player
        if not (player and player.valid) then break end -- player does not exist, don't run
        if not (player.realmo and player.realmo.valid) then break end -- player does not exist 2: revengence, don't run
		
		if (player.pflags & PF_SPINNING and player.speed > 15*FRACUNIT)
		or player.charability == CA_THOK and (player.pflags & PF_THOKKED and player.speed > 15*FRACUNIT) and not (player.pflags & PF_SHIELDABILITY)
		
            local traily = P_SpawnGhostMobj(player.mo)
            traily.fuse = 5
            traily.rollangle = player.mo.rollangle
            if (traily.tracer) then
                traily.tracer.fuse = 5
            end
        end
	end
end)

local function thicc(p)
	if p.jt == nil then
		p.jt = 0
		p.jp = false
		p.sp = false
		p.tk = false
		p.tr = false
	end
	if p.jt > 0 then
		p.jt = p.jt - 1
	end
	if p.jt < 0 then
		p.jt = p.jt + 1
	end
	if p.mo.momz < 1 then
		p.jp = false
	end
	if p.mo.state != S_PLAY_CLIMB and p.mo.eflags != p.mo.eflags | MFE_GOOWATER then
		if p.mo.momz > 0 and p.jp == false and p.mo.state != S_PLAY_FLY and p.mo.state != S_PLAY_SWIM and p.mo.state != S_PLAY_FLY_TIRED and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_RUN and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_BOUNCE_LANDING then
			p.jp = true
			p.jt = 5
		end
		if p.mo.momz > 0 and p.jt < 0 and p.mo.state != S_PLAY_FLY and p.mo.state != S_PLAY_SWIM and p.mo.state != S_PLAY_FLY_TIRED and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_RUN and p.mo.state != S_PLAY_WALK and p.mo.state != S_PLAY_BOUNCE_LANDING then
			p.jp = true
			p.jt = 5
		end
	elseif p.mo.eflags == p.mo.eflags | MFE_GOOWATER
		p.jp = true
	end
	if p.mo.state == S_PLAY_BOUNCE_LANDING then
		p.jt = -5
	end
	/*
	if p.pflags != p.pflags | PF_SPINNING or p.pflags == p.pflags | PF_JUMPED then
		p.sp = false
	end
	if p.pflags == p.pflags | PF_SPINNING and p.pflags != p.pflags | PF_JUMPED and p.sp == false and p.jt < 1 then
		p.sp = true
		p.jt = -5
	end
	*/
	if p.pflags != p.pflags | PF_THOKKED then
		p.tk = false
	end
	if p.pflags == p.pflags | PF_THOKKED and p.tk == false then
		p.tk = true
		p.jt = 5
	end
	if p.mo.state != S_PLAY_FLY_TIRED then
		p.tr = false
	end
	if p.mo.state == S_PLAY_FLY_TIRED and p.tr == false then
		p.tr = true
		p.jt = 5
	end
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 10
	p.mo.spriteyscale = p.maths + FRACUNIT
	
	p.maths = p.jt*p.spinheight
	if p.mo.state != S_PLAY_ROLL then
		p.maths = p.jt*p.height
	end
	p.maths = p.maths / 20
	p.mo.spriteyoffset = -1*p.maths
	
	p.maths = p.jt*FRACUNIT
	p.maths = p.maths / 10
	p.maths = p.maths*-1
	p.mo.spritexscale = p.maths + FRACUNIT
end
addHook("PlayerThink", thicc)
local function tailsthink(mo)
	mo.spriteyscale = mo.tracer.spriteyscale
	mo.spritexscale = mo.tracer.spritexscale
	mo.spriteyoffset = mo.tracer.spriteyoffset
end
addHook("MobjThinker", tailsthink, MT_TAILSOVERLAY)

addHook("PreThinkFrame", function()
	for player in players.iterate do										//You gotta be a player
		if player.fakeroll == nil then										//If player.fakeroll doesn't exist then
			player.fakeroll = 0										//make it exist
		end
		player.mo.rollangle = (player.mo.rollangle - player.fakeroll)
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do										//you gotta be a player
		if P_IsObjectOnGround(player.mo) and player.speed > 2000000 then					//you gotta be running on the ground
			player.fakeroll = ((player.mo.angle - R_PointToAngle(player.mo.x, player.mo.y)) / 2)		//The actual angle script
			if player.fakeroll > 200000000 then								//if you're going too far to the left then
				player.fakeroll = 200000000								//cap your angle
			end	
			if player.fakeroll < -200000000 then								//if you're going too far to the right then
				player.fakeroll = -200000000								//cap your angle
			end
		else													//if you're not running or you're not on the ground then
			player.fakeroll = 0										//become vertical again
		end
	end
end)

addHook("PostThinkFrame", function()
	for player in players.iterate do										//You gotta be a player
	player.mo.rollangle = (player.mo.rollangle + player.fakeroll)
	end
end)

//Enable the code below to draw some random crap (for debug reasons only)
//hud.add(function(v)
//	for player in players.iterate do
//		v.drawNum(160, 5, player.mo.rollangle, V_ORANGEMAP|V_30TRANS)
//		v.drawNum(160, 15, player.mo.angle, V_ORANGEMAP|V_30TRANS)
//		v.drawNum(160, 25, R_PointToAngle(player.mo.x, player.mo.y), V_ORANGEMAP|V_30TRANS)
//		v.drawNum(160, 35, player.speed, V_ORANGEMAP|V_30TRANS)
//	end
//end)

local function dropStart(player)
    player.isdropping = false
end

addHook("PlayerSpawn", dropStart)

local function dropThink(pl)
    if P_IsObjectOnGround(pl.mo) then
        pl.isdropping = false
    end
end

addHook("PlayerThink", function(player)
    if player.mo and player.mo.skin == "neostreak" then
        -- Your code for this condition goes here
    end -- Add this 'end' to close the 'if' block
end)

local function dropSpin(p)
    if skins[p.mo.skin].ability2 == CA_SPINDASH then
        return
    end

    if p.isdropping then
        return
    end

    local angle = p.mo.angle
    P_Thrust(p.mo, p.mo.angle, 20 * FRACUNIT)
    P_SetObjectMomZ(p.mo, 17 * FRACUNIT)

    S_StartSound(p.mo, sfx_zoom)
    p.isdropping = true
end

addHook("JumpSpinSpecial", dropSpin)


//Sonic Lost World Bounce Attack. made by me, MotdSpork. Boing!
addHook("MobjThinker", function(sonic)
	if (sonic and sonic.skin == "neostreak") //if you're sonic..
	and sonic.player.playerstate == PST_LIVE //you alive bruh?
		if sonic.player.bounceattack == nil //if the variable doesnt exist
			sonic.player.bounceattack = 0 //create variable
		end
		if sonic.player.bouncenumber == nil //if the variable doesnt exist
			sonic.player.bouncenumber = 0 //create variable
			sonic.player.justchangedbouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(sonic) //are you on the ground?
		and sonic.player.bounceattack == 0 //the player isnt bouncing
			sonic.player.bouncenumber = 0 //set it to zero!
		end
		if sonic.player.usedown == nil //if the variable doesnt exist
		or not (sonic.player.cmd.buttons & BT_CUSTOM3) //not pressing the spin button?
			sonic.player.usedown = 0 //create variable
			sonic.player.justchangedbouncenumber = 0 //create variable
		end
		if P_IsObjectOnGround(sonic) //Is the player on the ground?
		and (sonic.player.cmd.buttons & BT_CUSTOM3) //Is the player holding the spin button?
			sonic.player.usedown = 1 //Set it to one!
		end
		if sonic.player.pflags & PF_JUMPED //if the player has jumped
		and not (P_IsObjectOnGround(sonic)) //and you arent on the ground.
		and sonic.player.cmd.buttons & BT_CUSTOM3 //pressing custom2?
		and sonic.player.bounceattack == 0 //checking if the custom variable it set to 0
		and sonic.player.usedown == 0 //make sure you arent holding the spin button.
		and not (sonic.player.exiting) //not...exiting the level?
		and sonic.health //you're alive?
		and not (P_PlayerInPain(sonic.player)) //not hurt are you?
			sonic.player.bounceattack = 1 //set it to one!
			P_SetObjectMomZ(sonic, -45*FRACUNIT) //make the player "shoot" downward
			//P_SetObjectMomZ(sonic, FixedMul(-55*FRACUNIT, sonic.scale)) //make the player shoot downwards 
			sonic.player.pflags = $1|PF_THOKKED //force the player into a "thokked" state
		end

		if (sonic.eflags & MFE_JUSTHITFLOOR) //you're on the ground.
		and not (sonic.player.pflags & PF_SPINNING) //you arent spinning....somehow
		and not (sonic.player.pflags & PF_STARTDASH) //you arent doing a spindash
		and not (sonic.tracer and sonic.tracer.type == MT_TUBEWAYPOINT) //not in a...zoomtube?
		and sonic.player.bounceattack == 1 //our custom variable is one right...?
		and sonic.health //is the player alive..?
		and not (P_PlayerInPain(sonic.player)) //not hurt are you?
			if sonic.player.bouncenumber == 0 //if he hasnt bounced yet
			and sonic.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
				sonic.player.justchangedbouncenumber = 1 //now he has!
				sonic.player.bouncenumber = 1 //Set this to one!
				sonic.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(sonic, 12*FRACUNIT)
				if not (sonic.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					sonic.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if sonic.player.bouncenumber == 1 //if it's currently on his first bounce
			and sonic.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(sonic.player)) //not hurt are you?
				sonic.player.justchangedbouncenumber = 1 //now he has!
				sonic.player.bouncenumber = 1 //set this to two!
				sonic.player.pflags = $1|PF_JUMPED //forcing the player into a jumping state.
				P_SetObjectMomZ(sonic, 13*FRACUNIT)
				if not (sonic.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
					sonic.state = S_PLAY_ROLL //force the player into a spinning state.
				end
			end
			if sonic.player.bouncenumber == 2 //if it's currently on his second bounce
			and sonic.player.justchangedbouncenumber == 0 //if he hasnt left the ground yet
			and not (P_PlayerInPain(sonic.player)) //not hurt are you?
				sonic.player.justchangedbouncenumber = 1 //now he has!
				sonic.player.bouncenumber = 0 //set it back to zero
				sonic.state = S_PLAY_SPRING //change to spring frame, like is SLW!
				P_SetObjectMomZ(sonic, 17*FRACUNIT) //send the player upwards
				sonic.player.pflags = $1 & ~PF_JUMPED // No longer jumping. Don't land on an enemy!
			end
			sonic.player.bounceattack = 0 //set it back to zero.
			sonic.player.usedown = 1 //set it to one.

			S_StartSound(sonic, sfx_s3k77) //play a sound c:			
			
		end
		//some quick checks
		
		if sonic.player.bounceattack == 1 //checking our variable.
		and sonic.health //and you're alive
		and not (P_PlayerInPain(sonic.player)) //not hurt are you?
			P_SpawnThokMobj(sonic.player) //spawn the players thok object
			if not (sonic.player.panim == PA_ROLL) //checking if the players animation is it's spinning anim.
				sonic.state = S_PLAY_ROLL //force the player into a spinning state.
			end
			if (sonic.momz > (9000*P_MobjFlip(sonic))) // the player is going up...?  
				P_SetObjectMomZ(sonic, FixedMul(-55*FRACUNIT, sonic.scale)) //not anymore >.>
			end
		else 
			sonic.player.bounceattack = 0 //set it to 0
		end
		if sonic.player.bounceattack == 1 //checking if hes bouncing
			sonic.player.pflags = $1 & ~PF_SPINNING // you're no longer "spinning" if you were before
		end
		if not (sonic.player.pflags & PF_JUMPED) // if you are not actuallly jumping
			sonic.player.bounceattack = 0 //set this back to zero to be safe
		end
		
		if sonic.eflags & MFE_GOOWATER //is the player in THZ goop?
		or sonic.player.powers[pw_carry] //is the player being carried?
		//or sonic.player.pflags & PF_ROPEHANG //is the player on a ACZ ropehang?
			sonic.player.bounceattack = 0 //set to zero!
		end
		if not (sonic.player.pflags & PF_JUMPED) //if the player hasnt jumped
			sonic.player.bounceattack = 0 //set this to zero
		end
	end
end, MT_PLAYER)

local THOKSPEED = 60 * FRACUNIT
addHook("ThinkFrame", function(player)
    for player in players.iterate() do
        if player.mo and player.mo.skin == "neostreak" then
            local mo = player.mo
            if player and mo
            and mo.valid and player.playerstate == PST_LIVE
            and player.cmd.buttons & BT_CUSTOM1
            and (player.pflags & PF_JUMPED)
            and not (player.pflags & PF_THOKKED) then  -- Fix: Added 'then' here
                P_InstaThrust(mo, mo.angle, THOKSPEED)
                player.pflags = $ | PF_THOKKED
                player.pflags = $ & ~PF_NOJUMPDAMAGE
                mo.state = S_PLAY_ROLL
            end
        end
    end
end)


//Walljump lua first so we can check if the player is clinging or not first
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "neostreak")
			
			//if not (player.atwall)
				player.atwall = 0
			//end
			if not (player.cling)
				player.cling = false
			end
			if not (player.clingprev)
				player.clingprev = false
			end
			if (player.mo) //Fixes spectating, and possibly other things
				//Finding walls (not FOFs)
				local wall = R_PointInSubsector(player.mo.x+FixedMul(25*FRACUNIT, cos(player.mo.angle)), player.mo.y+FixedMul(25*FRACUNIT, sin(player.mo.angle))).sector
				local fheight = wall.floorheight
				local cheight = wall.ceilingheight

				if wall.f_slope then
					fheight = P_GetZAt(wall.f_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				if wall.c_slope then
					cheight = P_GetZAt(wall.c_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				
				if (fheight > player.mo.z) or ((cheight <= player.mo.height+player.mo.z) and not (fheight == cheight)/* and (wall.ceilingpic == "F_SKY1")*/) //This last bit seems to be broken...
					player.atwall = 1
				end
				//FOFs can be walls too, so lets check for those
				for wall in wall.ffloors()
					if (player.mo.z <= wall.topheight) and (player.mo.height+player.mo.z > wall.bottomheight)
						and(wall.flags & FF_BLOCKPLAYER) //Don't want the player to cling to water. That would be stupid
						player.atwall = $1 + 1
					end		
				end
				if(player.atwall <= 0)
					if (player.cling)
						player.pflags = $1&~PF_JUMPED
						player.mo.state = S_PLAY_FALL
					end
					player.cling = false
				end	
				if (P_IsObjectOnGround(player.mo))
					player.cling = false
				end	
				//This allows sonic to thok away from a wall. You can remove this if you dont want your character to do this.
				//Lazy checks
				if (player.powers[pw_carry] == CR_NONE) 
				and not (player.charability2 == CA2_MULTIABILITY)
					//If you're clinging to a wall
					if (player.cling)
						and not (player.cmd.buttons & BT_JUMP)
						if (player.powers[pw_underwater])
							P_SetObjectMomZ(player.mo, 25*FRACUNIT)
						else
							P_SetObjectMomZ(player.mo, 25*FRACUNIT)
						end
						S_StartSound(player.mo, sfx_s3k77)
						player.cling = false
						if (player.charability2 == CA2_SPINDASH)
							player.mo.state = S_PLAY_ROLL //L
						else
							player.mo.state = S_PLAY_SPRING //P
						end
						player.jumping = false
						P_InstaThrust(player.mo, player.mo.angle, -player.actionspd/3) //Devided by 3 for sonic, but you can remove this for your character
						player.mo.angle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
					end
					//Cling onto a wall
					if (player.atwall > 0)
						and (((player.mo.momz < -3*FRACUNIT+1) and not (player.mo.flags2 & MF2_OBJECTFLIP)) or ((player.mo.momz > 3*FRACUNIT-1) and (player.mo.flags2 & MF2_OBJECTFLIP)))
						and (player.pflags & PF_JUMPED)
						and (player.cmd.buttons & BT_CUSTOM1)
						and not (player.exiting)
						P_SetObjectMomZ(player.mo, -3*FRACUNIT)
						player.mo.momx = $1 / 2
						player.mo.momy = $1 / 2
						player.mo.state = S_PLAY_ROLL //F
						player.mo.frame = 2
						player.cling = true
						if (player.clingprev == false)
							S_StartSound(player.mo,sfx_s3k4a)
						end
						if not (S_SoundPlaying(player.mo,sfx_s3k7e))
							S_StartSound(player.mo, sfx_s3k7e)
						end
					end
				end			
				//Movement fix
				if (player.cling)
					player.normalspeed = 5
				else 
					player.normalspeed = skins[player.mo.skin].normalspeed
				end
				player.clingprev = player.cling	
			end		
		end
	end
end)

local THOKSPEED = 60 * FRACUNIT
addHook("ThinkFrame", function(player)
    for player in players.iterate() do
        if player.mo and player.mo.skin == "neostreak" then
            local mo = player.mo
            if player and mo
            and mo.valid and player.playerstate == PST_LIVE
            and player.cmd.buttons & BT_TOSSFLAG
            and (player.pflags & PF_JUMPED)
            and not (player.pflags & PF_THOKKED) then
                P_InstaThrust(mo, mo.angle, THOKSPEED)
                player.pflags = $ | PF_THOKKED
                player.pflags = $ & ~PF_NOJUMPDAMAGE
                mo.state = S_PLAY_ROLL
                S_StartSound(mo, sfx_thok)
            end
        end
    end
end)


//Walljump lua first so we can check if the player is clinging or not first
addHook("ThinkFrame", do
	for player in players.iterate
		if (player.mo and player.mo.skin == "neostreak")
			
			//if not (player.atwall)
				player.atwall = 0
			//end
			if not (player.cling)
				player.cling = false
			end
			if not (player.clingprev)
				player.clingprev = false
			end
			if (player.mo) //Fixes spectating, and possibly other things
				//Finding walls (not FOFs)
				local wall = R_PointInSubsector(player.mo.x+FixedMul(40*FRACUNIT, cos(player.mo.angle)), player.mo.y+FixedMul(40*FRACUNIT, sin(player.mo.angle))).sector
				local fheight = wall.floorheight
				local cheight = wall.ceilingheight

				if wall.f_slope then
					fheight = P_GetZAt(wall.f_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				if wall.c_slope then
					cheight = P_GetZAt(wall.c_slope, player.mo.x + player.mo.momx, player.mo.y + player.mo.momy)
				end
				
				if (fheight > player.mo.z) or ((cheight <= player.mo.height+player.mo.z) and not (fheight == cheight)/* and (wall.ceilingpic == "F_SKY1")*/) //This last bit seems to be broken...
					player.atwall = 1
				end
				//FOFs can be walls too, so lets check for those
				for wall in wall.ffloors()
					if (player.mo.z <= wall.topheight) and (player.mo.height+player.mo.z > wall.bottomheight)
						and(wall.flags & FF_BLOCKPLAYER) //Don't want the player to cling to water. That would be stupid
						player.atwall = $1 + 1
					end		
				end
				if(player.atwall <= 0)
					if (player.cling)
						player.pflags = $1&~PF_JUMPED
						player.mo.state = S_PLAY_FALL
					end
					player.cling = false
				end	
				if (P_IsObjectOnGround(player.mo))
					player.cling = false
				end	
				//This allows sonic to thok away from a wall. You can remove this if you dont want your character to do this.
				//Lazy checks
				if (player.powers[pw_carry] == CR_NONE) 
				and not (player.charability2 == CA2_MULTIABILITY)
					//If you're clinging to a wall
					if (player.cling)
						and not (player.cmd.buttons & BT_JUMP)
						if (player.powers[pw_underwater])
							P_SetObjectMomZ(player.mo, 20*FRACUNIT)
						else
							P_SetObjectMomZ(player.mo, 20*FRACUNIT)
						end
						S_StartSound(player.mo, sfx_jump)
						player.cling = false
						if (player.charability2 == CA2_SPINDASH)
							player.mo.state = S_PLAY_ROLL //L
						else
							player.mo.state = S_PLAY_SPRING //P
						end
						player.jumping = false
						P_InstaThrust(player.mo, player.mo.angle, player.actionspd/3) //Devided by 3 for sonic, but you can remove this for your character
						player.mo.angle = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
					end
					//Cling onto a wall
					if (player.atwall > 0)
						and (((player.mo.momz < -3*FRACUNIT+1) and not (player.mo.flags2 & MF2_OBJECTFLIP)) or ((player.mo.momz > 3*FRACUNIT-1) and (player.mo.flags2 & MF2_OBJECTFLIP)))
						and (player.pflags & PF_JUMPED)
						and (player.cmd.buttons & BT_TOSSFLAG)
						and not (player.exiting)
						P_SetObjectMomZ(player.mo, -3*FRACUNIT)
						player.mo.momx = $1 / 2
						player.mo.momy = $1 / 2
						player.mo.state = S_PLAY_ROLL //F
						player.mo.frame = 2
						player.cling = true
						if (player.clingprev == false)
							S_StartSound(player.mo,sfx_s3k4a)
						end
						if not (S_SoundPlaying(player.mo,sfx_s3k7e))
							S_StartSound(player.mo, sfx_s3k7e)
						end
					end
				end			
				//Movement fix
				if (player.cling)
					player.normalspeed = 5
				else 
					player.normalspeed = skins[player.mo.skin].normalspeed
				end
				player.clingprev = player.cling	
			end		
		end
	end
end)


local function RefreshAbility(player)
	player.pflags = $ | PF_JUMPED & ~PF_THOKKED
	player.secondjump = 0;
end

local function PreventAirWalk(player)
    if (player.mo.state == S_PLAY_WALK or player.mo.state == S_PLAY_RUN)
    and not player.powers[pw_carry]
        player.mo.state = S_PLAY_FALL
    end
end

local function SpinCharThink(player)
    -- Ignore if character is grounded
    if (P_IsObjectOnGround(player.mo))
    player.mo.ao_donecheck = false
    return
end

    PreventAirWalk(player)

    -- If spinning in the air
    if (player.pflags & PF_SPINNING)
        -- Turn off the spinning flag; this means you won't turn slowly like when rolling on ground
        player.pflags = $ & ~PF_SPINNING
        -- Use the jump state instead
        player.mo.state = S_PLAY_JUMP
        -- Enable air ability
        player.mo.ao_donecheck = true
    end

    if (player.mo.ao_donecheck and not player.mo.coyoteTime)
        player.mo.ao_donecheck = false
        RefreshAbility(player)
    end
end

local function NonSpinCharThink(player)
    -- Ignore if character is grounded
    if (P_IsObjectOnGround(player.mo))
        player.mo.ao_donecheck = false
        return
    end
    
    PreventAirWalk(player)
    
    if (player.mo.state == S_PLAY_SPRING)
        player.mo.ao_donecheck = false
    end

    if not (player.mo.ao_donecheck or player.mo.coyoteTime)
        player.mo.ao_donecheck = true
        RefreshAbility(player)
    end
end

local function AirOptionsThink(player)
    -- Run spin or nonspin character logic
    if (player.charflags & SF_NOJUMPSPIN)
        NonSpinCharThink(player)
    else
        SpinCharThink(player)
    end

end

addHook("PreThinkFrame", function()
	for player in players.iterate do
		AirOptionsThink(player);
	end
end)

--[[
    #####################################
   ## SPRING TRICKS                   --
  ## by ARJr                         --
 ## Based on Pointy/Fluffy's tricks --
##-----------------------------------
See below for info on how to add your own tricks to the list.
--]]

-- ##################################################
-- TRICK FUNCTIONS
-- These are used to actually animate the trick and determine when to stop the trick.

-- Pirouette A
local function TRICK_PirouetteA(player, ticker)
-- ticker is the same as the titlecard HUD hook ticker (the amount of time the trick has been going on for in tics)
	if ticker >= 16 then
		player.drawangle = player.SpringTricks.vars.storedangle
		-- Make sure to set trick-specific variables in player.SpringTricks.vars
		player.SpringTricks.vars.storedangle = nil
		player.mo.state = S_PLAY_FALL
		player.SpringTricks.tricking = false --< Set this to false when you want to end the trick
		return
	elseif ticker == 1 then
		player.SpringTricks.vars.storedangle = player.drawangle
	end
	
	player.drawangle = player.SpringTricks.vars.storedangle + (ticker*ANGLE_22h)
	player.mo.state = S_PLAY_EDGE
	player.mo.frame = 0
end

-- Pirouette B
local function TRICK_PirouetteB(player, ticker)
	if ticker >= 16 then
		player.drawangle = player.SpringTricks.vars.storedangle
		player.SpringTricks.vars.storedangle = nil
		player.mo.state = S_PLAY_FALL
		player.SpringTricks.tricking = false
		return
	elseif ticker == 1 then
		player.SpringTricks.vars.storedangle = player.drawangle
	end
	
	player.drawangle = player.SpringTricks.vars.storedangle + (ticker*ANGLE_22h)
	player.mo.state = S_PLAY_SPRING
	player.mo.frame = 0
end

-- Spin
local function TRICK_Spin(player, ticker)
	if ticker >= 9 then
		player.mo.state = S_PLAY_FALL
		player.SpringTricks.tricking = false
		return
	end
	
	if player.mo.state ~= S_PLAY_ROLL then
		player.mo.state = S_PLAY_ROLL
	end
end

-- Airwalk
local function TRICK_Airwalk(player, ticker)
	if ticker >= 16 then
		player.mo.state = S_PLAY_FALL
		player.SpringTricks.tricking = false
		return
	end
	
	if ticker % 2 == 0 then player.mo.state = S_PLAY_WALK end
end

-- Incredible (XMom)
local function TRICK_Incredible(player, ticker)
	if ticker >= 16 then
		player.mo.rollangle = 0
		if player.followmobj then player.followmobj.rollangle = 0 end
		S_StartSound(player.mo, sfx_kc48)
		player.SpringTricks.tricking = false --< Set this to false when you want to end the trick
		return
	end
	
	player.mo.rollangle = ticker*ANGLE_22h
	if player.followmobj then player.followmobj.rollangle = ticker*ANGLE_22h end
end

-- True Speed (Sonic)
local function TRICK_True(player, ticker)
	if ticker >= 15 then
		player.mo.flags2 = $ & ~MF2_DONTDRAW
		P_SpawnThokMobj(player)
		S_StartSound(player.mo, sfx_appear)
		S_StartSound(player.mo, sfx_skid)
		player.SpringTricks.tricking = false
		return
	elseif ticker == 1 then
		P_SpawnThokMobj(player)
	end
	player.mo.flags2 = $|MF2_DONTDRAW
end

-- Fly High (Tails)
local function TRICK_FlyHigh(player, ticker)
	if ticker >= 3*TICRATE/8 then
		player.mo.state = S_PLAY_FALL
		player.SpringTricks.tricking = false
		return
	end
	
	player.mo.state = S_PLAY_FLY
end

-- Chuckler (Knux)
local function TRICK_Chuck(player, ticker)
	if ticker >= 18 then
		player.mo.state = S_PLAY_FALL
		player.drawangle = player.SpringTricks.vars.storedangle
		player.SpringTricks.vars.storedangle = nil
		player.SpringTricks.tricking = false
		return
	elseif ticker == 1 then
		player.SpringTricks.vars.storedangle = player.drawangle
	end
	
	player.mo.state = S_PLAY_WAIT
	player.drawangle = player.SpringTricks.vars.storedangle + ANGLE_180
end

-- Hearty Cheer (Amy)
local function TRICK_Cheer(player, ticker)
	if ticker >= 13 then
		player.mo.state = S_PLAY_FALL
		player.SpringTricks.tricking = false
		return
	elseif ticker == 1 then
		local heart = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height, MT_LHRT)
		P_SetObjectMomZ(heart, 10*FRACUNIT)
		heart.fuse = TICRATE
		heart.target = player.mo
		player.mo.state = S_PLAY_NIGHTS_TRANS1
	end
	if player.mo.state != S_PLAY_NIGHTS_TRANS6 then
		player.mo.state = $+1
	else
		player.mo.frame = 6
	end
end

-- Red Handed (Fang)
local function TRICK_Ballin(player, ticker)
	if ticker >= 16 then
		player.drawangle = player.SpringTricks.vars.storedangle
		player.SpringTricks.vars.storedangle = nil
		player.mo.state = S_PLAY_FALL
		player.SpringTricks.tricking = false
		return
	elseif ticker == 1 then
		player.SpringTricks.vars.storedangle = player.drawangle
	end
	
	player.drawangle = player.SpringTricks.vars.storedangle + (ticker*ANGLE_22h)
	player.mo.state = S_PLAY_RUN
	player.mo.frame = $+1
end

-- Charge (Metal)
local function TRICK_Charge(player, ticker)
	if ticker >= 15 then
		player.mo.state = S_PLAY_FALL
		player.SpringTricks.tricking = false
		return
	end
	
	player.mo.state = S_METALSONIC_GATHER
end


-- ##################################################
-- TRICK LIST
-- The table used to store the tricks. Use dto pick a random trick to play.

local trickTable = {
	-- Format: {name = "Name of trick", char = "skinname", func = TRICK_Function, sound = sfx_sndid}
	{name = "Slickster", char = "sonic", func = TRICK_PirouetteA, sound = sfx_prloop},
	{name = "Flipshit", char = "sonic", func = TRICK_PirouetteB, sound = sfx_prloop},
	{name = "BADASS!", char = "neostreak", func = TRICK_Spin, sound = sfx_prloop},
	{name = "Airtrash", char = "tails", func = TRICK_Airwalk, sound = sfx_skid},
	{name = "INSANE!", char = "neostreak", func = TRICK_Incredible},
	{name = "True Speed", char = "sonic", func = TRICK_True, sound = sfx_zoom},
	{name = "Fly High", char = "tails", func = TRICK_FlyHigh, sound = sfx_putput},
	{name = "Chuckler", char = "knuckles", func = TRICK_Chuck, sound = sfx_nbmper},
	{name = "Cheerful Companion", char = "amy", func = TRICK_Cheer, sound = sfx_chchng},
	{name = "SICK!", char = "neostreak", func = TRICK_Ballin, sound = sfx_chchng},
	{name = "Charge Up", char = "metalsonic", func = TRICK_Charge, sound = sfx_kc4d}
}
rawset(_G, "TRICK_TrickList", trickTable)


-- ##################################################
-- THE CODE
-- The actual code for the trick handling. Only edit this if you know what you're doing!

local function RandTrick(skin)
	local randtrick = TRICK_TrickList[P_RandomRange(1, #TRICK_TrickList)]
	if randtrick.char == "all" or randtrick.char == skin then
		return randtrick
	end
	return RandTrick(skin) -- Recursive reshuffle
end

local trickScore = {
	1000,2000,3000,4000,5000,
	5000,10000,10000,10000,10000,
	20000,30000,40000,50000,60000,
	70000,80000,90000,1000000,1000000,
	1000000,1000000
}

addHook("PlayerThink", function(player)
	if not (player.mo and player.mo.valid and player.playerstate == PST_LIVE) then return end
	
	player.SpringTricks = $ or {
		vars = {},
		tricking = false,
		trickTicker = 0,
		trick = nil,
		chain = 0,
		trickbt = false,
		ready = false
	}
	
	if player.mo.eflags & MFE_SPRUNG then
		player.SpringTricks.ready = true
		if not player.SpringTricks.tricking then
			player.SpringTricks.chain = 0
		end
	elseif player.mo.eflags & MFE_JUSTHITFLOOR
	or player.mo.state == S_PLAY_PAIN
	or (P_IsObjectOnGround(player.mo) and player.SpringTricks.ready)
	or player.pflags & PF_THOKKED
	or player.mo.skipdove then -- Skip support issues
		player.SpringTricks.ready = false
		player.SpringTricks.trick = nil
		player.SpringTricks.tricking = false
		player.SpringTricks.chain = 0
		player.SpringTricks.trickTicker = 0
		player.mo.rollangle = 0
		if player.followmobj then player.followmobj.rollangle = 0 end
	end
	
	if player.cmd.buttons & BT_JUMP then
		if not player.SpringTricks.trickbt
		and player.SpringTricks.ready
		and not player.SpringTricks.tricking then
			player.SpringTricks.trick = RandTrick(player.mo.skin)
			player.SpringTricks.tricking = true
			player.SpringTricks.trickTicker = 1
			player.SpringTricks.chain = $+1
			local score = player.SpringTricks.chain
			if score > #trickScore then score = #trickScore end
			P_AddPlayerScore(player, trickScore[score])
			if player.SpringTricks.trick.sound then
				S_StartSound(player.mo, player.SpringTricks.trick.sound)
			end
		end
		player.SpringTricks.trickbt = true
	else
		player.SpringTricks.trickbt = false
	end
	
	if player.SpringTricks.trickTicker then
		player.SpringTricks.trick.func(player, player.SpringTricks.trickTicker)
		if not player.SpringTricks.tricking then
			player.SpringTricks.trickTicker = 0
		else
			player.SpringTricks.trickTicker = $+1
		end
	end
end)


-- ##################################################
-- THE HUD
-- Displaying the tricks.

hud.add(function(v, player)
	if not player.SpringTricks then return end
	
	if player.SpringTricks.ready then
		if not player.SpringTricks.trick then
			v.drawString(300, 8, "\x82Hot-dog!\x80", V_SNAPTOTOP|V_ALLOWLOWERCASE, "thin-right")
		else
			v.drawString(300, 8, player.SpringTricks.trick.name, V_YELLOWMAP|V_SNAPTOTOP|V_ALLOWLOWERCASE, "right")
			v.drawString(300, 16, "Chain "..player.SpringTricks.chain, V_SNAPTOTOP|V_ALLOWLOWERCASE|V_50TRANS, "thin-right")
		end
	end
end)

--Xian
--Kirb the Korb

-- Spin Dash turning modification
addHook("PlayerThink", function(player)

	--Apply only to players with the normal spindash
	if player.charability2 ~= CA2_SPINDASH then
		return
	end

	if (player.pflags & PF_SPINNING) 									-- Check to see if spinning
	and not (player.pflags & PF_STARTDASH) 								-- Revving the Spindash does not count
	and (P_IsObjectOnGround(player.mo))									-- Drifting only occures when on the ground
	and (player.cmd.forwardmove ~= 0) and (player.cmd.sidemove ~= 0)	-- only turn when the player wants to							
	and (player.speed > 1*FRACUNIT) then								-- minimum speed requirment


		-- Current information about the player
		local mom = FixedHypot(player.mo.momx, player.mo.momy)					-- Base Speed (No friction or drag)
		local motion = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy) 	-- base direction (No outside forces)

		-- Direction player is inputting
		local pangle = player.cmd.angleturn<<16 + R_PointToAngle2(0, 0, player.cmd.forwardmove*FRACUNIT, -player.cmd.sidemove*FRACUNIT)

		-- Calculate the new direction 
		local turn = 0
		local turning = FixedAngle(FixedMul(FixedDiv(AngleFixed(ANG2), 29*FRACUNIT/32), player.mo.friction)) -- scale by friction
		local dif = pangle - motion
		if dif > turning or dif < -turning then	-- Presision handling
			if dif > 0 then						-- Angle between 0 and 180 degrees (Left)
				turn = motion + turning	-- Turn Left
			else
				turn = motion - turning	-- Turn Right
			end
		else
			turn = pangle				--Go straight
		end

		-- Apply new movement and replace old movement
		P_InstaThrust(player.mo, turn, mom)

	end

end)

-- Scale dust made by the spindash to match how charged it is
local SpindustCheck = false
addHook("SpinSpecial", function(player)

	if not (skins[player.mo.skin].flags & SF_NOSPINDASHDUST)	-- Player's skin didn't already override the dust
	and (player.charability2 == CA2_SPINDASH)					-- Player's skin uses the Spindash
	and (player.pflags & PF_STARTDASH) 							-- Player is charging the spindash
	and (P_IsObjectOnGround(player.mo)) then					-- Player is on the ground

		player.charflags = $ | SF_NOSPINDASHDUST	-- Disable original spindash dust

		-- Check if player is in a liquid so that the spindash makes bubbles instead of dust
		local particleType
		if (player.mo.eflags & (MFE_TOUCHWATER | MFE_UNDERWATER)) then
			particleType = MT_SMALLBUBBLE
		else
			particleType = MT_SPINDUST
		end

		local charge = FixedDiv(player.dashspeed, player.maxdash)	-- Get a 0 - 1 percentage charge of the spindash

		if (P_RandomFixed() < charge + FU/2) then
			-- create dust particle and set its effects/scale/velocity based off of how charged the spindash is
			local dust = P_SpawnMobjFromMobj(player.realmo, P_RandomRange(-2, 2)*FU, P_RandomRange(-2, 2)*FU, 0, particleType)
			dust.momx = P_RandomRange(-2, 2) * charge
			dust.momy = P_RandomRange(-2, 2) * charge
			dust.momz = P_RandomRange( 0, 2) * charge
			P_Thrust(dust, player.mo.angle, -12 * charge)
			dust.destscale = 3 * charge / 2
		end

	end

	-- Change nothing else
	return false
end)

//Frostiikin was here.
addHook("PlayerThink", function(p)
    if p.mo and p.mo.valid and (p.cmd.buttons & BT_USE) and not (p.pflags & PF_SHIELDABILITY) and (p.charability2 == CA2_SPINDASH)
		if p.mo.state == S_PLAY_SPRING
		or p.mo.state == S_PLAY_FALL 
			p.mo.state = S_PLAY_JUMP
			p.pflags = $ |(PF_JUMPED)
			p.pflags = $ |(PF_THOKKED)
			p.pflags = $ & ~(PF_NOJUMPDAMAGE)
			S_StartSound(p.mo, sfx_spin)
		end
	end
end)

addHook("PlayerThink", function(player)
	if (player.powers[pw_invulnerability])
		local sparkletrail = P_SpawnGhostMobj(player.mo)
		sparkletrail.fuse = 13
		sparkletrail.blendmode = AST_ADD
		sparkletrail.color = player.mo.color
		sparkletrail.colorized = true
	end
end)