//cheezboi is smart
addHook("ShouldDamage", function(target, inflictor, damage)
	if target.skin == "neostreak" and (inflictor and inflictor.flags & MF_FIRE) then
		return false
	end
end, MT_PLAYER)

-- spike killer
addHook("MobjMoveCollide", function(player, spike)
	if player.skin == "neostreak" and
		(player.mo and player.mo.speeddash == true or player.boosting == true) then -- Update dash state check
		if spike.type == MT_SPIKE or spike.type == MT_WALLSPIKE then
			if player.z + player.height < spike.z or player.z > spike.z + spike.height then
				return false
			else
				P_KillMobj(spike, player, player)
			end
		end
	end
end)

addHook("ThinkFrame", function()
	for player in players.iterate do
		if player.mo and player.mo.skin == "neostreak" then
			if not player.mo.firerun then
				player.mo.firerun = 0
			end
			if player.mo.state == S_PLAY_DASH
				and P_IsObjectOnGround(player.mo)
				and not (player.mo.eflags & MFE_UNDERWATER) then
				P_ElementalFire(player)
				player.mo.firerun = 1
			end
		end
	end
end)
